// Fig. 20.42: fig20_42.cpp
// Demonstrating function objects.
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>

using namespace std;

// binary function adds the square of its second argument and
// the running total in its first argument and 
// returns the sum
int sumSquares( int total, int value ) 
   { return total + value * value; }

// binary function class template which defines an overloaded 
// operator() that function adds the square of its second 
// argument and the running total in its first argument and 
// returns the sum
template< class T > 
class SumSquaresClass : public binary_function< T, T, T >
{
public:
   const T &operator()( const T &total, const T &value )
      { return total + value * value; }
};

int main()
{
   const int SIZE = 10;
   int a1[] = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
   vector< int > v( a1, a1 + SIZE );
   ostream_iterator< int > output( cout, " " );
   int result = 0;

   cout << "vector v contains:\n";
   copy( v.begin(), v.end(), output );
   result = accumulate( v.begin(), v.end(), 0, sumSquares );
   cout << "\n\nSum of squares of elements in vector v using "
        << "binary\nfunction sumSquares: " << result;

   result = accumulate( v.begin(), v.end(), 0, 
                        SumSquaresClass< int >() );
   cout << "\n\nSum of squares of elements in vector v using "
        << "binary\nfunction object of type " 
        << "SumSquaresClass< int >: " << result << endl;
   return 0;
}